<template>
  <div class="dashboard-utlity-page pb-5">
    <h1 class="page-title">Bill Payments</h1>
    <div class="mt-3">
      <h6>1. Choose a Card</h6>
      <div class="row">
        <div class="col-sm-12 col-md-4">
          <div class="mt-2">
            <input
              id="currentAccountBalance"
              v-model="form.activeAccount"
              type="radio"
              name="activeAccount"
              value="currentAccountBalance"
              class="account-radio d-none"
            />
            <label for="currentAccountBalance" class="w-100">
              <CurrentAccountBalance />
            </label>
          </div>
          <div class="mt-3">
            <input
              id="savingsAccountBalance"
              type="radio"
              name="activeAccount"
              value="savingsAccountBalance"
              class="account-radio d-none"
            />
            <label for="savingsAccountBalance" class="w-100">
              <SavingsAccountBalance />
            </label>
          </div>
        </div>
        <div class="col-sm-12 col-md-8">
          <h6 class="fw-bold">Cable TV</h6>

          <div class="choose-transfer-type-card p-4">
            <div class="saved-beneficiary mt-1">
              <h5 class="fw-bold">Bills Payment - Cable TV</h5>
              <p>Paybills from the comfort of your home</p>
              <form @submit.prevent="utilityForm">
                <div class="row">
                  <div class="col-sm-12 col-md-6">
                    <div class="form-group">
                      <label class="mb-2">Choose Biller:</label>
                      <select
                        v-model="form.biller"
                        v-validate="'required'"
                        class="form-select"
                        name="Choose Biller"
                        @change="fetchPaymentList"
                      >
                        <option :value="null">Choose Biller</option>
                        <option
                          v-for="(biller, i) in cableBillers"
                          :key="i"
                          :value="biller"
                        >
                          {{ biller.billername }}
                        </option>
                      </select>
                      <div
                        v-show="verrors.has('Choose Biller')"
                        class="invalid-feedback"
                      >
                        {{ verrors.first('Choose Biller') }}
                      </div>
                    </div>
                    <div class="form-group my-3">
                      <label class="mb-2">Subscription Plans</label>
                      <select
                        v-model="form.subscriptionPlans"
                        v-validate="'required'"
                        class="form-select"
                        name="Subscription Plans"
                      >
                        <option :value="null">Choose Subscription Plans</option>
                        <option
                          v-for="(subscription, i) in subscriptionPlanList"
                          :key="i"
                          :value="subscription"
                        >
                          {{ subscription.paymentitemname }}
                        </option>
                      </select>
                      <div
                        v-show="verrors.has('Subscription Plans')"
                        class="invalid-feedback"
                      >
                        {{ verrors.first('Subscription Plans') }}
                      </div>
                    </div>
                    <div class="form-group my-3">
                      <label class="mb-2">Amount</label>
                      <input
                        v-validate="'required'"
                        class="form-control"
                        type="text"
                        :value="
                          form.subscriptionPlans &&
                          formatAmount(form.subscriptionPlans.amount)
                        "
                        name="Subscription Plans"
                        disabled
                      />
                      <div
                        v-show="verrors.has('Subscription Plans')"
                        class="invalid-feedback"
                      >
                        {{ verrors.first('Subscription Plans') }}
                      </div>
                    </div>
                    <div class="form-group my-3">
                      <label class="mb-2">Accout to Debit:</label>
                      <select
                        v-model="form.accountSource"
                        v-validate="'required'"
                        class="form-select"
                        name="Accout to Debit"
                      >
                        <option :value="null">Select Accout to Debit</option>
                        <option
                          v-for="(account, i) in userAccounts"
                          :key="i"
                          :value="account"
                        >
                          {{
                            `${account.AccountType} - ${account.AccountNumber}`
                          }}
                        </option>
                      </select>
                      <div
                        v-show="verrors.has('Accout to Debit')"
                        class="invalid-feedback"
                      >
                        {{ verrors.first('Accout to Debit') }}
                      </div>
                    </div>
                    <div class="form-group my-3">
                      <label class="mb-2">Smart Card Number</label>
                      <input
                        v-model="form.smartCardNumber"
                        v-validate="'required|integer'"
                        type="text"
                        class="form-control"
                        name="Smart Card Number"
                        @change="verifyCustomer()"
                      />
                      <div
                        v-show="verrors.has('Smart Card Number')"
                        class="invalid-feedback"
                      >
                        {{ verrors.first('Smart Card Number') }}
                      </div>
                    </div>

                    <div class="form-group my-3">
                      <label class="mb-2">Account Name</label>
                      <input
                        v-model="accountname"
                        v-validate="'required'"
                        type="text"
                        disabled
                        class="form-control"
                        name="Account Name"
                      />
                      <div
                        v-show="verrors.has('Account Name')"
                        class="invalid-feedback"
                      >
                        {{ verrors.first('Account Name') }}
                      </div>
                    </div>
                    <div class="form-group my-3">
                      <label class="mb-2">Transaction PIN</label>

                      <input
                        v-model="form.pin"
                        v-validate="'required'"
                        type="password"
                        class="form-control"
                        name="Transaction PIN"
                      />
                      <div
                        v-show="verrors.has('Transaction PIN')"
                        class="invalid-feedback"
                      >
                        {{ verrors.first('Transaction PIN') }}
                      </div>
                    </div>
                    <div class="form-group my-3">
                      <vs-button
                        :loading="form.active"
                        type="submit"
                        class="px-5 w-100"
                      >
                        Make Payment
                      </vs-button>
                    </div>
                  </div>
                </div>
              </form>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- MODALS -->
    <!-- Transaction Summary Modal -->
    <vs-dialog v-model="transactionSummaryModal" width="300px" not-center blur>
      <template #header>
        <h4 class="my-3">Transaction Summary</h4>
      </template>
      <vs-table class="my-2">
        <template #tbody>
          <vs-tr>
            <vs-td class="fw-bold"> Account to Debit: </vs-td>
            <vs-td> {{ transactionSummary.accountToDebit }} </vs-td>
          </vs-tr>
          <vs-tr>
            <vs-td class="fw-bold"> Amount: </vs-td>
            <vs-td> {{ transactionSummary.amount | formatPrice }} </vs-td>
          </vs-tr>
          <vs-tr>
            <vs-td class="fw-bold"> Payment Code: </vs-td>
            <vs-td> {{ transactionSummary.paymentCode }} </vs-td>
          </vs-tr>
          <vs-tr>
            <vs-td class="fw-bold"> Meter Number: </vs-td>
            <vs-td> {{ transactionSummary.customerId }} </vs-td>
          </vs-tr>
        </template>
      </vs-table>
      <vs-alert class="mt-3">
        <template #title> ARE YOU SURE YOU WANT TO PAY </template>
      </vs-alert>
      <div class="d-flex my-4 w-100 justify-content-between">
        <vs-button dark transparent @click="transactionSummaryModal = false">
          Cancel
        </vs-button>
        <vs-button
          :loading="form.active"
          class="px-5"
          type="submit"
          primary
          @click="submitForm()"
        >
          PAY
        </vs-button>
      </div>
      <template #footer> </template>
    </vs-dialog>

    <!-- Download Reciept -->
    <vs-dialog
      v-model="downloadRecieptModal"
      width="300px"
      not-center
      blur
      @close="redirect()"
    >
      <template #header>
        <h4 class="my-3">Do you want to save Beneficiary</h4>
      </template>

      <div class="text-center">
        <img
          src="@/assets/images/transfer-success-icon.png"
          alt="Transfer Successfull"
        />
      </div>
      <div class="px-5 text-center mt-3">
        <h3 class="fw-bold text-dark my-2">Transfer Successful!</h3>
        <p class="text-muted my-2 px-3">
          Congratulations, your transfer was completed successfully!
        </p>

        <div class="mt-3">
          <div class="row">
            <div class="col-sm-12 col-md-12">
              <div
                class="bg-light p-3 text-left"
                style="text-align: left !important"
              >
                <h5 class="fw-bold">{{ form.amount | formatPrice }}</h5>
                <p class="text-muted m-0" style="font-size: 10px">
                  * Note that the transfer might take a few minutes to reflect
                </p>
              </div>
            </div>
          </div>
        </div>

        <div class="mt-3">
          <div class="d-flex justify-content-between">
            <vs-button
              square
              warn
              gradient
              size="large"
              class="w-100"
              :href="recieptLink"
            >
              Download Receipts
            </vs-button>
          </div>
        </div>
        <div class="mt-3">
          <!-- <p class="text-primary fw-bold">Save Recipient as Beneficiary</p> -->
        </div>
      </div>
    </vs-dialog>
  </div>
</template>

<script>
export default {
  components: {},
  layout: 'dashboard',
  async asyncData({ $axios }) {
    const cableBillers = await $axios.$get('/bill/cable/billers')
    const userAccounts = await $axios.$get('/user/accounts')

    // console.log(cableBillers)
    return {
      cableBillers: cableBillers.payload,
      userAccounts: userAccounts.payload,
    }
  },
  data: () => ({
    form: {
      activeAccount: 'currentAccountBalance',
      biller: null,
      subscriptionPlans: null,
      active: false,
      accountTo: null,
      amount: null,
      transactionSummaryModal: false,
      transactionSummary: {},
      downloadRecieptModal: false,
      recieptLink: '',
    },
    accountname: '',
    transactionSummaryModal: false,
    transactionSummary: {},
    downloadRecieptModal: false,
    recieptLink: '',
    subscriptionPlanList: [],
  }),
  methods: {
    redirect() {
      window.location = '/user/dashboard/transaction-history'
    },
    verifyCustomer() {
      console.log(this.form.subscriptionPlans)
      if (!this.form.subscriptionPlans) {
        this.openNotification(
          'top-left',
          'warning',
          'Subscription Plan is required'
        )
        return
      }
      const data = {
        customerId: this.form.meterNumber,
        paymentCode: this.form.subscriptionPlans.paymentCode,
      }
      this.form.active = true
      this.$axios
        .$post('/bill/verify-customer', data)
        .then((response) => {
          this.form.active = false
          if (
            response.payload.responseCode === '70013' ||
            response.payload.responseCode === '70010'
          ) {
            this.openNotification(
              'top-left',
              'danger',
              response.payload.responseDescription
            )
            return
          }
          this.accountname = response.payload.fullName
        })
        .catch((error) => {
          this.form.active = false
          if (
            error.response.status === 404 ||
            error.response.status === 400 ||
            error.response.status === 401 ||
            error.response.status === 403 ||
            error.response.status === 406 ||
            error.response.status === 409
          ) {
            // console.log(error.response.data.message)
            this.openNotification(
              'top-left',
              'danger',
              error.response.data.message
            )
          }
        })
    },
    openNotification(position = null, color, message) {
      this.$vs.notification({
        progress: 'auto',
        color,
        position,
        title: message,
        text: '',
      })
    },
    formatAmount(value) {
      if (value === 0) return 0
      if (!value) return

      return (+value).toLocaleString('en-NG', {
        style: 'currency',
        currency: 'NGN',
      })
    },
    utilityForm() {
      // console.log(this.form)
      this.$validator.validateAll().then((result) => {
        // console.log(result)
        if (result) {
          this.transactionSummary = {
            amount: String(this.form.amount),
            accountToDebit: this.form.accountSource.AccountNumber,
            paymentCode: this.form.subscriptionPlans.paymentCode,
            customerId: this.form.meterNumber,
          }
          this.transactionSummaryModal = true
        }
      })
    },
    submitForm() {
      // console.log(this.form)
      this.$validator.validateAll().then((result) => {
        // console.log(result)
        if (result) {
          const data = {
            amount: this.form.subscriptionPlans.amount,
            transactionPin: this.form.pin,
            accountToDebit: this.form.accountSource.AccountNumber,
            paymentCode: this.form.subscriptionPlans.paymentCode,
            customerId: this.form.smartCardNumber,
          }
          this.form.active = true
          this.$axios
            .post('/bill/utility/pay', data)
            .then(({ data }) => {
              console.log(data)
              // this.createBeneficiaryModal = false
              this.form.active = false
              // eslint-disable-next-line
              // const modal = new bootstrap.Modal(
              //   document.getElementById('AirtimeSuccessModal'),
              //   {}
              // )
              // modal.show()
              // console.log(data)
              this.openNotification('top-left', 'success', data.message)
              this.recieptLink = data.payload.receipt
              this.transactionSummaryModal = false
              this.downloadRecieptModal = true
            })
            .catch((error) => {
              console.log(error)
              this.form.active = false
              if (
                error.response.status === 404 ||
                error.response.status === 400 ||
                error.response.status === 401 ||
                error.response.status === 403 ||
                error.response.status === 406 ||
                error.response.status === 409
              ) {
                // console.log(error.response.data.message)
                this.openNotification(
                  'top-left',
                  'danger',
                  error.response.data.message
                )
              } else {
                this.openNotification(
                  'top-left',
                  'danger',
                  error.response.data.message
                )
              }
            })
        }
      })
    },
    fetchPaymentList() {
      this.form.active = true
      this.$axios
        .$get(`bill/payment-items/${this.form.biller.billerid}`)
        .then((response) => {
          this.form.active = false
          this.subscriptionPlanList = response.payload.paymentitems
        })
        .catch(() => {
          this.form.active = false
        })
    },
  },
}
</script>

<style lang="scss">
@import '~@/assets/scss/index';
@import '~@/assets/scss/variables';

.text-sm {
  font-size: 12px;
}

.dashboard-utlity-page {
  .choose-transfer-type-card,
  .fill-beneficiary-details {
    background: #ffffff;
    border-radius: 20px;

    input.form-control,
    .form-select,
    textarea.form-control {
      background-color: #f4f2ec;
      border-radius: 5px;
      border: none;
    }
  }
  input.account-radio:checked + label {
    .account-card {
      // background-color: red;
      background-position: 98% 4%;
      background-image: url(~@/assets/images/tick.png);
    }
  }
}
</style>
